
       Program convgeo
	real*8 X(10),dis(3),a,b
	character*80 type,ifile,text
	integer*4 i,j
       write(6,*)'PLEASE READ CAREFULLY BEFORE DOWNLOADING OR USING THE'
       write(6,*)'PROGRAM'
       write(6,*)'__________'
       write(6,*)'DISCLAIMER'
       write(6,*)'__________'
       write(6,*)''
       write(6,*)'THIS SOFTWARE IS PROVIDED BY ISOLDE-TARGISOL, CERN,'
       write(6,*)'THE AUTHOR, AND CONTRIBUTORS "AS IS" AND ANY EXPRESS'
       write(6,*)'OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,'
       write(6,*)'THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS'
       write(6,*)'FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT'
       write(6,*)'SHALL CERN-ISOLDE, CERN, THE AUTHOR, OR CONTRIBUTORS'
       write(6,*)'BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,'
       write(6,*)'SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES'
       write(6,*)'(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF'
       write(6,*)'SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR'
       write(6,*)'PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND'
       write(6,*)'ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,'
       write(6,*)'STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR'
       write(6,*)'OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS'
       write(6,*)'SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH'
       write(6,*)'DAMAGE.'
       write(6,*)'____________'
       write(6,*)'USER LICENSE'
       write(6,*)'____________'
       write(6,*)''
       write(6,*)'By downloading the distribution files, you agree with'
       write(6,*)'the following conditions:'
       write(6,*)'- Title to the downloaded materials and all copies'
       write(6,*)'thereof remain with the ISOLDE, the European'
       write(6,*)'Organization for Nuclear Research (CERN for brief)'
       write(6,*)'and the author, M. Santana Leitner.'
       write(6,*)'- CERN-ISOLDE, and the author are the only official'
       write(6,*)'source of distribution of the code, bug fixes and'
       write(6,*)'documentation, as well as the unique recipients of'
       write(6,*)'the code intellectual property.'
       write(6,*)'- The software can be downloaded after acceptance of'
       write(6,*)'these conditions only from the dedicated CERN WEB'
       write(6,*)'server (http://msantana.web.cern.ch/msantana).'
       write(6,*)'- The downloaded software cannot be redistributed as'
       write(6,*)'a whole, partly or in any modified way. Please,'
       write(6,*)'address interested users to the provided website.'
       write(6,*)'- The downloaded software can be used free of charge'
       write(6,*)'by scientific and non profit organization. For'
       write(6,*)'commercial use ad hoc agreements have to be'
       write(6,*)'negotiated.'
       write(6,*)'- The code or parts of it can be inserted into other'
       write(6,*)'codes only after an official permission is granted by'
       write(6,*)'CERN-ISOLDE, AND the author. The combined software,'
       write(6,*)'after the permission is obtained, can be used free of'
       write(6,*)'charge by scientific and non profit organizations.'
       write(6,*)'For commercial use ad hoc agreements have to be'
       write(6,*)'negotiated.'
       write(6,*)'- The author welcomes user contribution to the code,'
       write(6,*)'that might be included in the code, acknowledging and'
       write(6,*)'properly referencing the originators. Possible'
       write(6,*)'contributions to the code must be sent separately and'
       write(6,*)'documented to the author, who will be the sole'
       write(6,*)'responsible for accepting them for inclusion in the'
       write(6,*)'distributed code.'
       write(6,*)'- The use of the code must be acknowledged explicitly'
       write(6,*)'by quoting the following reference:'
       write(6,*)'  M. Santana Leitner, "A Monte Carlo code to optimize'
       write(6,*)'the production of radioactive ion beams by the ISOL'
       write(6,*)'Technique.", Ph.D. Thesis, UPC-ETSEIB (2005).'
       write(6,*)'- Moreover users of the code are asked to provide'
       write(6,*)'feedback (through the website/email) about the'
       write(6,*)'activities/results of its use.'
       write(6,*)'- For questions/clarifications/problems about the'
       write(6,*)'license please contact:'
       write(6,*)'    Mario Santana Leitner, @'
       write(6,*)'    http://cern.ch/ribo'
       write(6,*)''
       write(6,*)' DID YOU READ THE LISENCE??'
       write(6,*)''
       write(6,*)'------------------------------------------'
        j=1
        write(6,*)'how do you wish to name the input file?'
        read*,ifile
        OPEN(UNIT=2,FILE=ifile)
        write(2,*)'Surfaces'
        write(2,*)'n   RC   T    x2    y2    z2    xy   xz    yz  ...'
 10     write(6,*)'surface number',j

        i=1
	DO WHILE (i.le.10)
           X(i)=0
	   i=i+1
        END DO
 	write(6,*)'P:plane,S:Sphere,C:Cylinder,K:cone,SQ:elipse,GQ:gen'
	read*,type
   	IF (type.eq.'S') THEN
 	  write(6,*)'Radius=?'
          read*,X(10)
	  X(10)=X(10)*X(10)
	  X(1)=1
	  X(2)=1
	  X(3)=1
        ELSE IF (type.eq.'P') THEN
          write(6,*)'YZ (PX), XZ (PY), XY (PZ), AX+BY+CZ=D (P)'
	  read *,type
          IF (type.eq.'PX') THEN
            X(7)=1
          ELSE IF (type.eq.'PY') THEN
            X(8)=1
 	  ELSE IF (type.eq.'PZ') THEN
            X(9)=1
          ELSE IF (type.eq.'P') THEN
	    write(6,*)'A,B,C'
            read *,X(7),X(8),X(9)
	  END IF
          write(6,*)'position?'  	
	  read*,X(10)
        ELSE IF (type.eq.'C') THEN
          write(6,*)'Radius=?'
	  read*,X(10)
	  X(10)=X(10)*X(10)
	  write(6,*)'CX, CY, CZ?'
	  read *,type
          IF (type.eq.'CX') THEN
            X(2)=1
	    X(3)=1
          ELSE IF (type.eq.'CY') THEN
            X(1)=1
	    X(2)=1
 	  ELSE IF (type.eq.'CZ') THEN
            X(1)=1
	    X(2)=1
          END IF
        ELSE IF (type.eq.'SQ') THEN
 	  write(6,*)'R1,R2,R3?'
	  read *,X(1),X(2),X(3)
	  X(1)=X(1)*X(1)
     	  X(2)=X(2)*X(2)
	  X(3)=X(3)*X(3)
          X(10)=1 
        ELSE   
	  write(6,*)'give 10 parameters of equation'
	  write(6,*)'a*x^2+b*y^2+c*z^2+d*x*y+e*x*z+f*y*z+g*x+h*y+i*z=j'
	  read *,X
        END IF

        write(6,*)'eq: ',X
	write(6,*)'rotation? give polar angles of new x vector'
        write(6,*)'(polar,azimuthal)=(90,0) ==> no rotation'
	read *,a,b
        CALL rotate(X,a,b)
	write(6,*)'traslation?give x0,y0,z0'
	read *,dis
	CALL translate(X,dis)
        write(6,*)'what is the temperature of the surface[K]?'
        read*,a
        write(2,*)j,0.5,a,X
        write(6,*)'add surface? (Y/N)'
        read*,type
        IF (type.eq.'Y') THEN
           j=j+1
           goto 10
        END IF
       END
